import Vue from 'vue'
import Vuex from 'vuex'

import csAppWindowsUtils from './global/csAppWindowsUtils'
import csDeviceDetection from './global/csDeviceDetection'
import csServerSettings from './global/csServerSettings'
import i18n from './global/i18n'


Vue.use(Vuex)

export function createStore() {
  return new Vuex.Store({
    modules: {
      i18n,
      csDeviceDetection,
      csAppWindowsUtils,
      csServerSettings
    },
    strict: process.env.NODE_ENV !== 'production',
    plugins: []
  })
}
